<cfsetting enablecfoutputonly="yes"><cfprocessingdirective suppresswhitespace="Yes">
<!------------------------------------------------------------------------------------------
This is the Techspedition Fusebox core file, copyright (c) 2002, by Techspedition, Inc., all rights rserved
USE OF THIS FILE INDICATES YOUR ACCEPTANCE OF ITS LICENSE TERMS (also posted at the Techspedition.com web site). These terms are relatively easy to understand: you may use this file without restriction as long as this notice remains intact. The changing of any part of this file, whether in documentation or in code, renders your license to use this file null and void.
Version: 3.00.21
Language: ColdFusion (CF5 or higher) 
Platform: Windows
------------------------------------------------------------------------------------------->
 
<!------------------------------------------------------------------------------------------
This file is broken into twelve sections. 
Section One is the Fusedoc for the file.
Section Two contains the public "API-style" variables that are used in the Fusebox framework.
Section Three established the private structure "fb_".
Section Four is the former formURL2attributes Custom Tag.
Section Five includes the fbx_circuits.cfm file.
Section Six creates a mirror of the fusebox.circuits strucure for reverse look-ups.
Section Seven includes the root fbx_settings.cfm file.
Section Eight massages attributes.fuseaction and begins the aliased lookup process.
Section Nine includes nested fbx_settings.cfm files top-to-bottom.
Section Ten includes the target circuit fbx_switch file, which processes the requested fuseaction.
Section Eleven includes any layout files, in bottom-to-top order to allow layouts to be nested. It also outputs the final display of the page.
------------------------------------------------------------------------------------------->

<!------------------------------------------------------------------------------------------
SECTION ONE
For more information about Fusedocs and how to read them, visit fusebox.org . The ending HTML comment after the opening CFML comment prevents CFStudio from comment-coloring the Fusedoc.
------------------------------------------------------------------------------------------->
<!--- 
<fusedoc fuse="techspeditionFBcore_CF50_v3_00_21.cfm">
	<responsibilities>
		This is the core code behind the Fusebox 3.0 functionality, as implemented by Techspedition, Inc. (www.techspedition.com), and is copyright (c) 2002, by Techspedition, Inc.  All rights reserved.
		USE OF THIS FILE INDICATES YOUR ACCEPTANCE OF ITS LICENSE TERMS (also posted at the Techspedition web site). These terms are relatively easy to understand: you may use this file without restriction as long as this notice remains intact. The changing of any part of this file, whether in documentation or in code, renders your license to use this file null and void.
	</responsibilities>
	<properties>
		<property name="version" value="3.00" />
		<property name="build" value="21" />
		<history role="Architect" type="Create" author="John Quarto-vonTivadar" date="15 Jul 2002" email="johnq@techspedition.com">substantially large portions of this code are taken from the public release of the Fusebox 3.0 core file; please consult that file for a list of additional contributors to that core file.</history>
		<note>deprecated Fusebox 3.0 API variables: fusebox.IsHomeCircuit, fusebox.IsTargetCircuit, fusebox.layout . These variables are nevertheless available when using this core file as required to maintain compliancy with the official FB specification.</note>
		<note>additional Techspedition Fusebox API variables: techspedition.FuseQ, techspedition.localQ, techspedition.CompletedFuseQ, techspedition.content (replaces the deprecated fusebox.layout), techspedition.flushcontent, techspedition.generatedContent, techspedition.suppresscontent, techspedition.fuseMode, techspedition.ContentComponentVariable. These variables are available only when using this core file; your use of these variables outside of the core file is predicated upon your use of this core file.</note>
		<note>deprecated Fusebox API methods: none.   These methods are nevertheless available when using this core file as required to maintain compliancy with the official FB specification.</note>
		<note>additional Techspedition Fusebox API methods: IsHomeCircuit(), IsTargetCircuit(), FrontOfQ(), BackOfQ(), ClearQ(), SuperCircuit(), Super(), SuperQ(), AddToQ(), NextinQ(), SuppressContent(), FlushContent(), IsPermitted(). These methods are available only when using this core file; your use of these methods outside of the core file is predicated upon your use of this core file. </note>		
		<note>correction to the Fusebox 3.0 core file: the top level fbx_Settings.cfm file was loading without setting fusebox.thisCircuit equal to the circuit alias of the home circuit. The Techspedition core file corrects that.</note>
		<note>modification to Fusebox 3.0 core file: if both a FORM and URL variable with the same name are passed, this core file will throw an error and abort processing.</note>
		<note>modification to the Fusebox 3.0 core file: if the passed in attributes.fuseaction references a non-existant circuit then the top-most circuit of the app is assumed</note>
		<note>modification to Fusebox 3.0 core file: the API variable fusebox.Layoutfile can contain a comma-delimited list of layout files to be applied for a given circuit. Previously, the core file could only process a single file. All the files must be in the same relative directory as specified by the standard API variable fusebox.LayoutDir</note>
		<note>modification to Fusebox 3.0 core file: errors generated by the core file during its attempt to include various associated core helper files (fbx_Settings.cfm, fbx_Circuits.cfm, fbx_Switch.cfm, fbx_Layouts.cfm) will now throw a specific error only when the error occurs in the actual process of including these files (or their components) using CFCATCH TYPE=MISSINGINCLUDE. Previously ALL errors were so caught, including those not the fault of the core file, which made bug-catching difficult and the API variable fusebox.suppresserrors virtually useless</note>
		<note>modification to Fusebox 3.0 core file: if a requested fuseaction is a dot-delimited list of more than two elements, then only the first two will be considered when determining the actual target circuit and actual target fuseaction</note>
	</properties>
	<io>
		<out>
			<structure name="fusebox" scope="variables" comments="this is the public API of variables that should be treated as read-only">
				<boolean name="isCustomTag" default="FALSE" />
				<boolean name="isHomeCircuit" default="FALSE" />
				<boolean name="isTargetCircuit" default="FALSE" />
				<string name="fuseaction" comments="will be assigned a literal value of 'fusebox.defaultfuseaction' if attributes.fuseaction comes in as 'circuit.' with no fuseaction passed." />
				<string name="circuit" />
				<string name="homeCircuit" />
				<string name="targetCircuit" />
				<string name="thisCircuit" />
				<string name="thisLayoutPath" />
				<boolean name="suppressErrors" default="FALSE" />
				<string name="currentPath" />
				<string name="rootPath" />
				<string name="layout" />
			</structure>				
			<structure name="techspedition" scope="variables" comments="This is the Techspedition public API of variables that should be treated as read-only">
				<string name="FuseQ" comments="This is part of the Techspedition core file" />
				<string name="localQ" comments="This is part of the Techspedition core file" />
				<string name="CompletedFuseQ" comments="this is part of the Techspedition core file" />
				<string name="content" comments="This is part of the Techspedition core file" />				
				<boolean name="flushcontent" default="true" comments="This is part of the Techspedition core file. Should the content generated by the just completed fuse be flushed as output (if not, it is carried forward to the next fuse)" />
				<string name="generatedContent" comments="This is part of the Techspedition core file. A running compilation of all content generated by each completed fuse listed in techspedition.completedQ since before the last Flush plus anything left in techspedition.WorkingContent as of the end of the FuseQ" />
				<string name="WorkingContent" comments="This is part of the Techspedition core file. A running compilation of all content generated by each completed fuse in techspedition.completedQ since the last Flush" />
				<string name="ContentComponentVariable" comments="This is part of the Techspedition core file. The content component variable name created by pushing content generated by the current fuseaction into the content component varaible. Content created this way is not saved in techspedition.WorkingContent nor techspedition.GeneratedContent" />
				<boolean name="ContentComponentAppend" default="false" comments="This is part of the Techspedition core file. When handling Content Component variables, determines if any new content created for the content component variable should be appended to the current value of that variable (TRUE) or should overwrite the previous value of the variable (FALSE)" />
				
			</structure>
			<structure name="FB_" comments="Internal use only. Please treat the FB_ as a reserved structure, not to be touched.">
			</structure>
			<structure name="techspedition_" comments="Internal use only. Please treat the techspedition_ as a reserved structure, not to be touched.">
			</structure>
		</out>
	</io>
</fusedoc> 
--->

<cfscript>
/*******************************************************************************************
SECTION TWO
The fusebox structure below is a structure encompassing the public Fusebox API. We recommend making no changes to this structure as it will render your application non-compliant to the Fusebox 3.0 standard.

	fusebox.IsCustomTag:
The boolean variable is set by the Fusebox framework which will automatically determine if it is being called as a custom tag. Currently, Fusebox offers to expanded support for applications being called as Custom Tags. But you can programatically alter your application if it's being called as Custom Tag by checking the value of this variable. This can be helpful for changing (or removing altogether) layout files in fbx_layouts.cfm.
	fusebox.IsHomeCircuit:
This boolean variable is set and re-set as the Fusebox framework does its business pulling in fbx_settings.cfm files and the fbx_switch.cfm file and fbx_layouts.cfm files (and associated layout files). It is TRUE only when the currently accessed circuit is the home circuit running this application.
	fusebox.IsTargetCircuit:
Like isHomeCircuit above, this boolean variable is used during the process of cfincluding files. It is TRUE only when the currently accessed circuit is the target circuit running specified by circuit.fuseaction.
	fusebox.Circuit:
This is the first part of the compound fuseaction that gets passed as attributes.fuseaction.
	fusebox.Fuseaction:
This is the second part of a compound fuseaction that gets passed as attributes.fuseaction. fusebox.fuseaction is the variable expression evaluated in fbx_switch.cfm.
	fusebox.HomeCircuit:
This variable is set to the root-level circuit as defined in fusebox.circuits strucure.
	fusebox.TargetCircuit:
This is the circuit the requested fuseaction is to run in. The difference between this variable and fusebox.circuit above, is that this variable is the circuit alias that was found in the fusebox.circuits file as opposed to the circuit that is being attempted to be found. In all non-error situations fusebox.TargetCircuit and fusebox.Circuit will be the same.
	fusebox.ThisCircuit:
Like IsTargetCircuit and IsHomeCircuit above, this variable is set and re-set during the process of running the fbx_settings.cfm files and the fbx_switch.cfm file, and refers to the circuit alias of the circuit from which files are currently being accessed.
	fusebox.ThisLayoutPath:
This is the directory path that the layout file being used is called from. This variable changes as the layouts are nested one inside another, building the overall page layout.
	fusebox.suppressErrors:
A boolean variable, which defaults to FALSE. If TRUE, the Fusebox framework will attempt to give you "smarter" errors that may occur from within its own code as it applies to the Framework itself. If FALSE (default), you will receive the native CF error messages. During development you may want to turn this to TRUE and FALSE alternately to ensure you've got your framework set up properly. Set this to TRUE in a production enviroment, since at that point errors that occur will not be Fusebox framework errors but rahter erros in your fuseactions and fuses.	
	fusebox.Circuits:
This variable is a structure whose aliases are the circuit names created in fbx_circuits.cfm and whose values are the directory paths to those circuits.
	fusebox.currentPath:
This variable takes you from the root circuit to any location it is called. If you use images in directories beneath individual circuits, this variable will point to that circuit like "directory/directory/".
	fusebox.rootPath:
This variable takes you from the circuit it is being called from, back to the root. This is helpful to determine your location relative to the root application.
	fusebox.layout:
This string represents all of the content generated between opening and ending of the most recent CFSAVECONTENT tag (or a custom tag equivalent thereof)
*******************************************************************************************/
/*******************************************************************************************
TECHSPEDITION SECTION TWO
	techspedition.FuseQ:
This string is a comma-delimited list of the fuseactions yet to be performed.
	techspedition.localQ:
This string is a comma-delimited list of the fuseactions yet to be performed, local to the current fuseaction. At the end of the current fuseaction localQ will be prepended to FuseQ.
	techspedition.CompletedFuseQ:
This string is a comma-delimited list of the fuseactions successfully completed.
	techspedition.content:
This string is a replacement for fusebox.layout which has been renamed to account for the expanded nature of the work it does with the FuseQ context. This refers to the content generated by the current fuseaction in the FuseQ only
	techspedition.WorkingContent
This string is an accumulation of all the content generated for display since the last FlushContent()
	techspedition.generatedContent:
This string repesents all the content generated by the page request. As content is flushed it is stored here and at the end of the page request anything remaining in techspedition.WorkingContent is stored here as well. This variable will represent a full output of what is seen on the screen (useful for creating static sites)
	techspedition.FuseMode:
This string represents the mode of fuse this is in the FuseQ. The default FuseMode is FUSE; currently the only other recognized FuseMode is LAYOUT
	techspedition.FlushContent:
This boolean, which defaults to FALSE, determines whether the core file should flush any content generated up to this point since the FuseQ began or since the last FlushContent was TRUE. It affects techspedition.content but not techspedition.generatedContent
	techspedition.SuppressContent:
This boolean, which resets to FALSE at the start of every Fuseaction in the FuseQ, allows any content generated by the current fuseaction to not be saved into techspedition.WorkingContent and/or techspedition.GeneratedContent
	techspedition.ContentComponentVariable:
This string is the name of the varaible in which the current fuseaction in the FuseQ is storing its generated output. When a content component is being used, output is not sent to techspedition.WorkingContent
	techspedition.ContentComponentAppend:
This boolean determines whether the generated output written to the techspedition.ContentComponentVariable overwrites the old value (FALSE) or appends to it (TRUE)
*******************************************************************************************/

fusebox = structNew();
if (findNoCase("cf_", "," & getBaseTagList()))
	fusebox.IsCustomTag=TRUE;
else fusebox.IsCustomTag=FALSE;
fusebox.IsHomeCircuit=FALSE;
fusebox.IsTargetCircuit=FALSE;
fusebox.fuseaction="";
fusebox.circuit="";
fusebox.HomeCircuit="";
fusebox.TargetCircuit="";
fusebox.thisCircuit="";
fusebox.thislayoutpath="";
fusebox.suppressErrors=FALSE;
fusebox.Circuits=structNew();
fusebox.currentPath="";
fusebox.rootPath="";
fusebox.layout="";

techspedition = structNew();
techspedition.FuseQ="";
techspedition.localQ="";
techspedition.CompletedFuseQ="";
techspedition.content="";
techspedition.GeneratedContent="";
techspedition.WorkingContent="";
techspedition.FlushContent=FALSE;
techspedition.FuseMode="FUSE";
techspedition.ContentComponentVariable="";
techspedition.ContentComponentAppend=FALSE;
techspedition.SuppressContent=FALSE;

techspedition_ = structNew();
techspedition_.Circuits = structNew();
techspedition_.Circuits.PhysicalPath = structNew();
techspedition_.Circuits.VirtualPath = structNew();
techspedition_.Circuits.PhysicalPathToAppRoot = structNew();
</cfscript>

<cfif NOT fusebox.IsCustomtag>
	<cfinclude template="techspeditionFBcoremethods_CF50_v3_00_21.cfm">
</cfif>

<cfscript>
/*******************************************************************************************
SECTION THREE
FB_ is a structure encompassing "private" variables used by the underlying Fusebox framework. Make no changes to it without a full understanding of the ramifications of those changes. 
*******************************************************************************************/
FB_=structNew();

/*******************************************************************************************
SECTION FOUR
This code used to be in a Custom Tag called formURL2attributes.cfm. It copies all incoming FORM and URL variables to ATTRIBUTES scope.
If a variable exists with the same name in both FORM and URL scope then the core file will throw an error and abort
*******************************************************************************************/
if (NOT IsDefined("attributes"))
    attributes=structNew();
StructAppend(attributes, url, "no");
StructAppend(attributes, form, "no");
</cfscript>
<cfloop list="#StructKeyList(url)#" index="aURLvar">
	<cfif StructKeyExists(form, aURLvar)>
		<cfoutput>The variable "#aURLvar#" exists in both the FORM and URL scope. This presents a problem when copying the variables to the ATTRIBUTES scope. </cfoutput>
		<cfabort>	
	</cfif>
</cfloop>

<!------------------------------------------------------------------------------------------
SECTION FIVE
Attempt to include the fbx_circuits.cfm file, which should be in the same directory as this fbx_fusebox30_CF5x.cfm file.
------------------------------------------------------------------------------------------->
<cftry>
   <cfinclude template="fbx_Circuits.cfm"> 
	<cfcatch type="MissingInclude">
		<cfif cfcatch.missingFileName NEQ  'fbx_Circuits.cfm'>
			<cfrethrow>
		<cfelse>
			<cfoutput>The Fusebox framework could not find the required file "fbx_Circuits.cfm". </cfoutput><cfabort>		
		</cfif>
	</cfcatch>
</cftry>
<!--- if the techspedition_.Circuits.PhysicalPath and techspedition_.Circuits.VirtualPath aren't already populated then calculate them
 --->
<cfscript>
	if (StructCount(techspedition_.Circuits.PhysicalPath) EQ 0 AND StructCount(techspedition_.Circuits.VirtualPath) EQ 0) {
		for (aCircuit in fusebox.Circuits){
			techspedition_.Circuits.PhysicalPath[aCircuit] = ListRest(fusebox.Circuits[aCircuit], "/");
			if (Len(techspedition_.Circuits.PhysicalPath[aCircuit]) AND Right(techspedition_.Circuits.PhysicalPath[aCircuit],1) NEQ "/") techspedition_.Circuits.PhysicalPath[aCircuit] = techspedition_.Circuits.PhysicalPath[aCircuit] & "/";
			techspedition_.Circuits.VirtualPath[aCircuit] = "";
			FB_.temp = fusebox.Circuits[aCircuit];
			while (ListLen(FB_.temp,"/")) {
				for (aCircuitName in fusebox.Circuits){
					if (FB_.temp EQ fusebox.Circuits[aCircuitName]) {
						techspedition_.Circuits.VirtualPath[aCircuit] = ListPrepend(techspedition_.Circuits.VirtualPath[aCircuit], aCircuitName );
						break;
					}
				}
				FB_.temp = ListDeleteAt(FB_.temp,ListLen(FB_.temp,"/"),"/");
			}
		}
	}

	// now calculate the PhysicalPathToAppRoot
	FB_.currentdir = GetDirectoryFromPath(GetCurrentTemplatePath());
	FB_.currentdir = ReplaceNoCase(FB_.currentdir,'\','/','ALL');

	for (aCircuit in techspedition_.Circuits.PhysicalPath){
		FB_.physicalpath = techspedition_.Circuits.PhysicalPath[aCircuit];
		if (FB_.physicalpath EQ "" and fusebox.homecircuit EQ "") fusebox.homecircuit = aCircuit;
		FB_.PathToRoot = "";
	
		if (ListFindNoCase(FB_.physicalPath,'..','/')) {
			FB_.dotdotslash_count = ListLen(FB_.physicalpath,'/') - ListLen(ReplaceNoCase(FB_.physicalpath,'../','' ,'ALL' ), '/');
			for(aNum=1; aNum LTE ListLen(FB_.currentdir,'/'); aNum=aNum+1) {
				if (aNum LTE FB_.dotdotslash_count) FB_.PathToRoot = ListAppend(FB_.PathToRoot,ListGetAt(FB_.currentdir,ListLen(FB_.currentdir,'/')+1-aNum,'/'), '/');
			}
			for(aNum=1; aNum LTE ListLen(FB_.physicalpath,'/'); aNum=aNum+1) {
				anItem = ListGetAt(FB_.physicalpath, aNum, '/');
				if (anItem NEQ "..") FB_.PathToRoot = ListPrepend(FB_.PathToRoot, '..', '/');
			}
			if (Len(FB_.PathToRoot)) FB_.PathToRoot = FB_.PathToRoot & "/";

		} else {
			FB_.PathToRoot = RepeatString('../',ListLen(FB_.physicalPath, '/'));
		}
			
		techspedition_.Circuits.PhysicalPathToAppRoot[aCircuit] = FB_.PathToRoot;
	}
</cfscript>

<!------------------------------------------------------------------------------------------
SECTION SIX
NO LONGER REQUIRED
Create a reverse path look-up of the fusebox.Circuits structure which can be used later to conveniently look up the circuit alias of whichever circuit is being accessed at that moment, particularly when determining fusebox.thisCircuit. 
------------------------------------------------------------------------------------------->


<!------------------------------------------------------------------------------------------
SECTION SEVEN
Attempt to include the fbx_settings.cfm file from the root directory, the same directory that this file is being run from.
------------------------------------------------------------------------------------------->
	<cftry>
	<cfset fusebox.thisCircuit = fusebox.HomeCircuit> <!--- this line corrects a bug in the official FB3 core files! --->
	<cfset fusebox.currentPath = techspedition_.Circuits.PhysicalPath[fusebox.homecircuit]>
	<cfset fusebox.rootPath = techspedition_.Circuits.PhysicalPathToAppRoot[fusebox.homecircuit]>
	<cfset fusebox.IsHomeCircuit = TRUE><!--- not really needed since the UDF IsHomeCircuit() is available but it is put in for backward compatibility --->
	
	<cfoutput><cfinclude template="fbx_Settings.cfm"></cfoutput><!--- the CFOUTPUT tags correct a bug in the official core files --->
	<cfcatch type="MissingInclude">
		<cfif cfcatch.missingFileName NEQ  'fbx_Settings.cfm'>
			<cfrethrow>
		<cfelse>
			<cfoutput>The Fusebox framework could not find the required file "fbx_Settings.cfm" in the root circuit "#fusebox.thiscircuit#". A fbx_Settings.cfm file is required in at least the root circuit. </cfoutput><cfabort>		
		</cfif>
	</cfcatch>
	</cftry>

<cfset techspedition.FuseQ = attributes.fuseaction>
<cfset FB_.thisFA = "">

<cfloop condition="#listlen(techspedition.FuseQ)# GT 0">
	
	<cfset techspedition.localQ = "">
	<cfset techspedition.SuppressContent = FALSE>
	<cfset techspedition.flushcontent = FALSE>


	<!--- peel the next fuseaction off of the front of the FuseQ --->
	<cfset FB_.thisFA = trim(ListFirst(techspedition.FuseQ))>
	<cfset techspedition.FuseQ = ListRest(techspedition.FuseQ)>
	
<!------------------------------------------------------------------------------------------
SECTION EIGHT
Dissect attributes.fuseaction (available in the attributes scope either from being converted in the formURL2attributes section or via the above included fbx_settings.cfm file in the root directory). If attributes.fuseaction is not a compound fuseaction (i.e. it only includes the circuit in the form of "?fuseaction=circuit."), then set the fuseaction as blank, which the target circuit's CFDEFAULTCASE tag will pick up. Now look up the target circuit in the fusebox.circuit structure for the full path to the circuit.
------------------------------------------------------------------------------------------->
	<cftry>
		<cfscript>
		FB_.rawFA = FB_.thisFA;

		techspedition_.OldContentComponentVariable = techspedition.ContentComponentVariable;
		techspedition_.temp =   ListFindNoCase(FB_.rawFA, 'INTO', ' ');
		techspedition.ContentComponentVariable = "";
		techspedition_.ContentComponentAppend = FALSE;

		if (techspedition_.temp GT 0) {
			techspedition.ContentComponentVariable = Trim( ListGetAt(FB_.rawFA,techspedition_.temp+1,' ') );
			if (NOT IsDefined('#techspedition.ContentComponentVariable#')) "#techspedition.ContentComponentVariable#" = "";
			if (techspedition.ContentComponentVariable NEQ techspedition_.OldContentComponentVariable) techspedition.content = "";
			techspedition.SuppressContent = TRUE;
			FB_.rawFA = ListDeleteAt(FB_.rawFA, techspedition_.temp+1, ' ');
			FB_.rawFA = ListDeleteAt(FB_.rawFA, techspedition_.temp, ' ');
		}			

		techspedition_.temp = ListFindNoCase(FB_.rawFA, 'APPEND', ' ');
		if (techspedition_.temp GT 0) {
			techspedition_.ContentComponentAppend = TRUE;
			FB_.rawFA = ListDeleteAt(FB_.rawFA, techspedition_.temp, ' ');
		}

		techspedition.FuseMode = ' ' & ListRest( FB_.rawFA, ' ' ) & ' '; //determine the Fuse Type
		techspedition.FuseMode = ReplaceNoCase(techspedition.FuseMode, ' AS ', '', 'ALL');
		techspedition.FuseMode = ReplaceNoCase(techspedition.FuseMode, ' AND ', '', 'ALL');
		techspedition.FuseMode = ReplaceNoCase(Trim(techspedition.FuseMode), ' ', ',', 'ALL');
		if (techspedition.FuseMode EQ '') techspedition.FuseMode = "Fuse"; // if no mode was specified then assume it's "FUSE"

		//preserve the raw fuseaction for later use and determine if any parameters need to be parsed
		FB_.rawFA = ListFirst( FB_.thisFA, ' ');
		techspedition_.parameters = ListRest(FB_.rawFA, '?'); 
		FB_.rawFA = Trim(ListFirst( FB_.rawFA, '?'));
		</cfscript>

		<!--- parse any passed parameters --->
		<cfloop list="#techspedition_.parameters#" delimiters="&" index="aParam">
			<cfset techspedition_.name = trim(URLdecode(ListFirst(aParam, '=')))>
			<cfset techspedition_.value = URLdecode(ListLast(aParam, '='))>
			<cfset "#techspedition_.name#" = techspedition_.value>
		</cfloop>
					
		<cfscript>
		// determine fuseaction
		if (ListLen(FB_.rawFA, '.') is 1) {
			fusebox.fuseaction = FB_.rawFA;
			if (Right(FB_.rawFA,1) is '.') { fusebox.fuseaction = "fusebox.defaultfuseaction"; } //circuit only specified, no fuseaction, such as "fuseaction=circuit."
			if (Left(FB_.rawFA,1) is '.') { fusebox.fuseaction = RemoveChars(FB_.rawFA, 1, 1); } //fuseaction only specified, no circuit, such as "fuseaction=.fuseaction"
		
		} else { //else we got a fully-qualified fuseaction such as "circuit.fuseaction"
			fusebox.fuseaction = ListGetAt( FB_.rawFA, 2,  '.' ); 
		}
		// determine circuit
		fusebox.circuit = ListGetAt( FB_.rawFA, 1, '.');

		if (NOT StructKeyExists(techspedition_.Circuits.VirtualPath, fusebox.circuit) ) fusebox.circuit = fusebox.homecircuit;//if the circuit specified doesn't exist default the circuit to the home circuit
		fusebox.TargetCircuit=fusebox.circuit; //preserve for later
		</cfscript>
		<cfcatch>
			<!--- In this case, we want the core file custom error message to always display, since this code is solid, but the attributes.fuseaction may be incorrect and thus produce an error. --->
			<cfoutput>The variable "attributes.fuseaction" is not available or the Fusebox framework could not find the circuit you requested: "#fusebox.circuit#". If you think this error is incorrect, turn off the Fusebox suppress error messages flag by setting fusebox.SuppressErrors to FALSE, and you will receive ColdFusion's "normal" error output.</cfoutput><cfthrow message="#cfcatch.message#" detail="#cfcatch.detail#"><cfabort>
		</cfcatch>
	</cftry>

<!------------------------------------------------------------------------------------------
SECTION NINE
Attempt to include any nested fbx_Settings.cfm files, in top-to-bottom order so that variables set in children fbx_settings.cfm files can overwrite variables set in higher fbx_settings.cfm files. To prevent children fbx_settings.cfm files from overwriting variables, use CFPARAM rather than CFSET. Alternately, any child fbx_settings.cfm can CFSET a variable and lower fbx_settings.cfm files cannot overwrite it unless they use CFSET. If any fbx_settings.cfm file or directory alias cannot be found, continue on.
------------------------------------------------------------------------------------------->
	<cfloop list="#techspedition_.Circuits.VirtualPath[fusebox.targetcircuit]#" index="aCircuit">
		<cfset fusebox.thiscircuit = trim(aCircuit)>
		<cfif fusebox.thiscircuit EQ fusebox.homecircuit><cfset fusebox.IsHomeCircuit = TRUE><cfelse><cfset fusebox.IsHomeCircuit = FALSE></cfif>
		<cfif fusebox.thiscircuit EQ fusebox.targetcircuit><cfset fusebox.IsTargetCircuit = TRUE><cfelse><cfset fusebox.IsTargetCircuit = FALSE></cfif>
		<cfset fusebox.currentpath = techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]>
		<cfset fusebox.rootPath = techspedition_.Circuits.PhysicalPathToAppRoot[fusebox.thiscircuit]>

		<cftry>
			<cfoutput><cfinclude template="#techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]#fbx_Settings.cfm"></cfoutput><!--- note the CFOUTPUT tags around the fbx_settings files correct a bug in the official core files --->
			
			<cfcatch type="MissingInclude">
				<cfif Fusebox.suppressErrors>
					<cfif cfcatch.missingFileName NEQ  'fbx_settings.cfm'><cfrethrow></cfif>
				<cfelse>
					<cfif cfcatch.missingFileName NEQ  'fbx_settings.cfm'>
						<cfrethrow>
					<cfelse>
						<cfoutput>The Fusebox framework could not find the file "fbx_Settings.cfm" in the "#fusebox.thiscircuit#" circuit (the circuit's physical directory path, relative to the root circuit, is "#techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]#). While this is not a required file for this circuit, it is highly recommended that you include a "fbx_Settings.cfm" file in each of your circuits for completeness. <p>This error message can be suppressed by setting the Fusebox API variable Fusebox.suppresserrors = TRUE in your top-level fbx_Settings.cfm file.</cfoutput><cfabort>
					</cfif>
				</cfif>
			</cfcatch>
		</cftry>
	</cfloop>

<!------------------------------------------------------------------------------------------
SECTION TEN
Now "reach down" and include the fbx_switch.cfm in the target circuit, executing fusebox.fuseaction. Store the contents of the output into a variable called techspedition.content   (a copy is made to fusebox.layout, for backward compatibility).
------------------------------------------------------------------------------------------->
	<cfscript>
	fusebox.thisCircuit=fusebox.TargetCircuit;
	fusebox.IsTargetCircuit= TRUE;
	if (fusebox.TargetCircuit EQ fusebox.HomeCircuit) {
		fusebox.IsHomeCircuit = TRUE;
	} else {
		fusebox.IsHomeCircuit = FALSE;
	}
	if (techspedition.ContentComponentVariable EQ "") {
		techspedition.content = techspedition.WorkingContent;
	} else {
		techspedition.content = "#Evaluate(techspedition.ContentComponentVariable)#";
	}
	fusebox.currentpath = techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit];
	fusebox.rootPath = techspedition_.Circuits.PhysicalPathToAppRoot[fusebox.thiscircuit];

	</cfscript>
	<cftry>
		<cfsavecontent variable="techspedition.content">
			<cfoutput>
			<cfif NOT ListFindNoCase( techspedition.FuseMode, "layout" )>#techspedition.content#</cfif><cfinclude template="#techspedition_.Circuits.PhysicalPath[fusebox.TargetCircuit]#fbx_Switch.cfm"></cfoutput><!---include the target fbx_switch.cfm file--->
		</cfsavecontent>
		<cfset fusebox.layout = techspedition.content>
		
		<cfcatch type="MissingInclude">
			<cfif cfcatch.missingFileName NEQ  'fbx_Switch.cfm'>
				<cfrethrow>
			<cfelse>
				<cfoutput>The Fusebox framework could not find the required file "fbx_Switch.cfm" in the target circuit "#fusebox.thiscircuit#". A fbx_Switch.cfm file is required in every circuit. </cfoutput><cfabort>		
			</cfif>
		</cfcatch>
	</cftry> 

<!------------------------------------------------------------------------------------------
SECTION ELEVEN
Now handle the layouts, resolving them in bottom-to-top order to nest the circuits, if needed. Also set fusebox.thisCircuit equal to the circuit name of the current circuit the code is passing through, which will let any layout files in circuits know where they are. If attempting to include any layout file throws an error, then do nothing and continue on. This ENTIRE section and functionality of nesting layouts and controlling layouts via layout files is optional. If you do not have any layout files (fbx_layout.cfm), or only have a layout file in your root directory, everything will still work.
------------------------------------------------------------------------------------------->

	<cfloop from="#ListLen(techspedition_.Circuits.VirtualPath[fusebox.targetcircuit])#" to="1" step="-1" index="FB_.i">
		<cfset fusebox.thiscircuit = trim(ListGetAt(techspedition_.Circuits.VirtualPath[fusebox.targetcircuit], FB_.i))>
		<cfif fusebox.thiscircuit EQ fusebox.homecircuit><cfset fusebox.IsHomeCircuit = TRUE><cfelse><cfset fusebox.IsHomeCircuit = FALSE></cfif>
		<cfif fusebox.thiscircuit EQ fusebox.targetcircuit><cfset fusebox.IsTargetCircuit = TRUE><cfelse><cfset fusebox.IsTargetCircuit = FALSE></cfif>
		<cfset fusebox.currentPath = techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]>
		<cfset fusebox.rootPath = techspedition_.Circuits.PhysicalPathToAppRoot[fusebox.thiscircuit]>

	 	<cftry> 
			<!--- include the fbx_Layouts.cfm file for this circuit which decides which layout file to use--->
			<cfinclude template="#techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]#fbx_Layouts.cfm">

			<cfcatch type="MissingInclude">
				<cfif Fusebox.suppressErrors>
					<cfif cfcatch.missingFileName NEQ  'fbx_Layouts.cfm'>
						<cfrethrow>
					<cfelse>
						<cfset fusebox.layoutfile = ""><cfset fusebox.layoutdir = "">			
					</cfif>
				<cfelse>
					<cfif cfcatch.missingFileName NEQ  'fbx_Layouts.cfm'>
						<cfrethrow>
					<cfelse>
						<cfoutput>The Fusebox framework could not find the file "fbx_Layouts.cfm" in the "#fusebox.thiscircuit#" circuit (the circuit's physical directory path, relative to the root circuit, is "#techspedition_.Circuits.PhysicalPath[fusebox.thiscircuit]#). While this is not a required file for this circuit, it is highly recommended that you include a "fbx_Layouts.cfm" file in each of your circuits for completeness. <p>This error message can be suppressed by setting the Fusebox API variable Fusebox.suppresserrors = TRUE in your top-level fbx_Settings.cfm file.</cfoutput><cfabort>
					</cfif>
				</cfif>
			</cfcatch>
	 	</cftry>
		
	
			<!--- Start building up the layout... --->
			<cfif Len(fusebox.layoutfile)>
				<cfloop list="#fusebox.layoutfile#" index="aFile">
					<cftry>
						<!--- Save the current contents of the fuse as techspedition.content (a copy is made ot fusebox.layout for backward compatibility) --->
						<cfsavecontent variable="techspedition.content">	
							<cfoutput><cfinclude template="#fusebox.currentPath##fusebox.layoutdir##trim(aFile)#"></cfoutput>
						</cfsavecontent>
						<cfset fusebox.layout = techspedition.content>

					<cfcatch type="MissingInclude">
						<cfif Fusebox.suppressErrors>
							<cfif cfcatch.missingFileName NEQ  '#trim(aFile)#'>
								<cfrethrow>	
							</cfif>
						<cfelse>
							<cfif cfcatch.missingFileName NEQ  '#trim(aFile)#'>
								<cfrethrow>
							<cfelse>
								<cfoutput>The Fusebox framework could not find the layoutfile "#fusebox.currentPath##fusebox.layoutdir##trim(aFile)#" specified by "#fusebox.thislayoutpath#fbx_Layouts.cfm" of circuit "#fusebox.thiscircuit#".</cfoutput><cfabort>							</cfif>
						</cfif>

					</cfcatch>
					</cftry>
				</cfloop>
			</cfif>
			
	</cfloop>

<!------------------------------------------------------------------------------------------
SECTION TWELVE
Now do some final clean-up work and loop over the FuseQ
------------------------------------------------------------------------------------------->
	
	
	<cfif Len(techspedition.localQ)>
		<cfset techspedition.FuseQ = ListPrepend(techspedition.FuseQ, techspedition.localQ)>
	</cfif>

	
	<cfif techspedition.ContentComponentVariable EQ "">
		<cfif NOT techspedition.SuppressContent>
			<cfset techspedition.WorkingContent = techspedition.content>
		</cfif>
	<cfelse>
		<cfset "#techspedition.ContentComponentVariable#" =  techspedition.content>
	</cfif>


	<!--- Finally, output the totally-nested layout --->
	<cfif techspedition.flushcontent OR techspedition.FuseQ EQ "">
		<cfset techspedition.GeneratedContent = techspedition.GeneratedContent & techspedition.WorkingContent>
		<cfoutput>#techspedition.WorkingContent#</cfoutput>
	    <cfif techspedition.flushcontent>
			<cfset techspedition.WorkingContent ="">
		</cfif>
	</cfif>
	
	<cfset techspedition.CompletedFuseQ = listAppend(techspedition.CompletedFuseQ, FB_.thisFA)>
	
</cfloop>
</cfprocessingdirective><cfsetting enablecfoutputonly="no">